/***** spin: pangen1.h *****/

/* Copyright (c) 1991-1998 by Lucent Technologies - Bell Laboratories     */
/* All Rights Reserved.  This software is for educational purposes only.  */
/* Permission is given to distribute this code provided that this intro-  */
/* ductory message is not removed and no monies are exchanged.            */
/* No guarantee is expressed or implied by the distribution of this code. */
/* Software written by Gerard J. Holzmann as part of the book:            */
/* `Design and Validation of Computer Protocols,' ISBN 0-13-539925-4,     */
/* Prentice Hall, Englewood Cliffs, NJ, 07632.                            */
/* Send bug-reports and/or questions to: gerard@research.bell-labs.com    */

/* dSpin extension written by Radu Iosif. Feedback: iosif@athena.polito.it */


static char *Code2[] = { /* the tail of procedure run() */
	"#if defined(VERI) && !defined(NOREDUCE) && !defined(NP)",
	"  if (!state_tables) {",
	"    printf(\"warning: for p.o. reduction to be valid \");",
	"    printf(\"the never claim must be stutter-closed\\n\");",
	"    printf(\"(never claims generated from LTL \");",
	"    printf(\"formulae are stutter-closed)\\n\");",
	"  }",
	"#endif",
	"  UnBlock;	/* disable rendez-vous */",
	"",
	"  _hinit();",
	"",
	"#if defined(FULLSTACK) && defined(BITSTATE)",
	"  _onstack_init();",
	"#endif",
	"",
	"#ifdef CNTRSTACK",
	"  LL = (uchar *) emalloc(1<<(ssize-3));",
	"#endif",
	"",
	"  stack  = (Stack *) emalloc(sizeof(Stack));",
	"  svtack = (Svtack *) emalloc(sizeof(Svtack));",
	"",
	"  /* a place to point for Pptr of non-running procs: */",
        "  noptr    = (P *) emalloc(sizeof(P));",
	"  now.pool = (P **) emalloc((MAXPROC+1) * sizeof(P *));",
	"  A_Root.pool = (P **) emalloc((MAXPROC+1) * sizeof(P *));",
	"",
	"  for (i = 0; i < MAXPROC+1; i ++)",
	"    A_Root.pool[i] = (P *) emalloc(sizeof(P));",
	"",
	"#ifdef VERI",
	"  Addproc(VERI);	/* never - pid = 0 */",
	"#endif",
	"",
	"  active_procs();	/* started after never */",
	"",
	"#ifdef EVENT_TRACE",
	"  now._event = start_event;",
	"  reached[EVENT_TRACE][start_event] = 1;",
	"#endif",
	"",
	"#ifdef BITSTATE",
	"go_again:",
	"#endif",
	"  do_the_search();",
	"",
	"#ifdef BITSTATE",
	"  if (-- Nrun > 0 && HASH_CONST[++ HASH_NR]) {",
	"    printf(\"Run %%d:\\n\", HASH_NR);",
	"    wrap_stats();",
	"    printf(\"\\n\");",
	"    memset(SS, 0, 1<<(ssize-3));",
	"#ifdef CNTRSTACK",
	"    memset(LL, 0, 1<<(ssize-3));",
	"#endif",
        "#ifdef FULLSTACK",
	"    memset((char *)S_tab, 0, (1<<(ssize-3))*sizeof(struct H_el *));",
	"#endif",
	"    nstates = nlinks = truncs = truncs2 = ngrabs = 0;",
	"    nlost = hcmp = 0;",
	"    Fa = Fh = Zh = Zn = 0;",
	"    PUT = PROBE = ZAPS = Ccheck = Cholds = 0;",
	"    goto go_again;",
	"  }",
	"#endif /* BITSTATE */",
	"}\n\n",

	"#if !defined(SAFETY) && !defined(BITSTATE)",
	"#if !defined(FULLSTACK) || defined(MA)",
	"#define depth_of(x)	A_depth /* an estimate */",
	"#else",
	"int depth_of(struct H_el *s)",
	"{",
	"  Trail *t; int d;",
	"",
	"  for (d = 0; d <= A_depth; d++) {",
	"    t = &trail[d];",
	"    if (s == t->ostate)",
	"      return d;",
	"  }",
	"",
	"  printf(\"pan: cannot happen (depth_of)\\n\");",
	"  return depthfound;",
	"}",
	"#endif",
	"#endif /* !defined(SAFETY) && !defined(BITSTATE) */\n\n",

	"void do_the_search(void)",
	"{",
	"  int i;",
	"",
	"  depth = mreached = 0;",
	"  trpt = &trail[depth];",
	"",
	"#ifdef VERI",
	"  trpt->tau |= 4;	/* the claim moves first */",
	"#endif",
	"",
	"  for (i = 0; i < (int) now._nr_pr; i ++) {",
	"    P *ptr = pptr(i);",
	"#ifndef NP",
	"    if (!(trpt->o_pm & 2) && accpstate[ptr->_t][ptr->_p])",
	"      trpt->o_pm |= 2;",
	"#else",
	"    if (!(trpt->o_pm & 4) && progstate[ptr->_t][ptr->_p])",
	"      trpt->o_pm |= 4;",
	"#endif /* NP */",
	"  }",
	"",
	"#ifdef EVENT_TRACE",
	"#ifndef NP",
	"  if (accpstate[EVENT_TRACE][now._event])",
	"    trpt->o_pm |= 2;",
	"#else",
	"  if (progstate[EVENT_TRACE][now._event])",
	"    trpt->o_pm |= 4;",
	"#endif",
	"#endif /* EVENT_TRACE */",
	"",
	"#ifndef NOFAIR",
	"  if (fairness && (a_cycles && (trpt->o_pm & 2))) {",
	"    now._a_t = 2;	                /* set the A-bit */",
	"    now._cnt[0] = now._nr_pr + 1;",	/* NEW: +1 */
	"  }",
	"#endif /* NOFAIR */",
	"",
	"  if (spsec && gettimeofday(&start_tp, NULL)) {",
	"    fprintf(efd, \"get time failed: %%s\\n\", strerror(errno));",
	"    exit(0);",
	"  }",
	"",
	"  new_state();	/* start 1st DFS */",
	"}\n\n",

	"void delproc(int save, int h)",
	"{",
	"  _delproc(save, h);",
	"}\n\n",

	"void sv_save(State *won)",
	"{",
	"  _sv_save(won);",
	"}\n\n",

	"void sv_restor()",
	"{",
	"  _sv_restor();",
	"}\n\n",

	"void p_restor(int h)",
	"{",
	"  _p_restor(h);",
	"}\n\n",

	"void p_q_restor(int h, int kk)",
	"{",
	"  _p_q_restor(h, kk - 1);",
	"}\n\n",

	"void p_q_save(int h, int kk)",
	"{",
	"  _p_q_save(h, kk - 1);",
	"}\n\n",

	"#ifdef INLINE_REV",
	"char do_reverse(Trans *t, short II, char M)",
	"{",
	"  char m = M;",
	"  short tt = (short)this->_p;",
	"#include \"pan.b\"",
	"R999:",
	"  return m;",
	"}",
	"#endif /* INLINE_REV */\n\n",

	"#ifndef INLINE",
	"#ifdef EVENT_TRACE",
	"static char _tp = 'n';",
	"static int _qid = 0;",
	"#endif /* EVENT_TRACE */\n\n",

	"char do_transit(Trans *t, short II, int n)",
	"{",
	"  char m;",
	"  short tt = (short)this->_p;",
	"#define continue	return 0",
	"#include \"pan.m\"",
	"P999:",
	"  return m;",
	"#undef continue",
	"}\n\n",

	"#ifdef EVENT_TRACE",
	"void require(char tp, int qid)",
	"{",
	"  Trans *t;",
	"",
	"  _tp = tp;",
	"  _qid = qid;",
	"",
	"#ifdef NEGATED_TRACE",
	"  if (now._event == endevent) {",
	"    depth ++;",
	"    trpt ++;",
	"    uerror(\"event_trace error (all events matched)\");",
	"#ifndef NP",
	"    if (accpstate[EVENT_TRACE][now._event])",
	"      trpt->o_pm |= 2;",
	"#else",
	"    if (progstate[EVENT_TRACE][now._event])",
	"      trpt->o_pm |= 4;",
	"#endif",
	"    trpt--;",
	"    depth --;",
	"    now._event = start_event;",
	"    return;",
	"  } else",
	"#else",
	"  if (now._event != endevent)",
	"#endif /* NEGATED TRACE */",
	"    for (t = trans[EVENT_TRACE][now._event]; t; t = t->nxt) {",
	"       if (do_transit(t, EVENT_TRACE, 0)) {",
	"         now._event = t->st;",
	"         reached[EVENT_TRACE][t->st] = 1;",
	"#ifndef NP",
	"         if (accpstate[EVENT_TRACE][now._event])",
	"	    (trpt + 1)->o_pm |= 2;",
	"#else",
	"	  if (progstate[EVENT_TRACE][now._event])",
	"           (trpt + 1)->o_pm |= 4;",
	"#endif /* NP */",
	"	  for (t = t->nxt; t; t = t->nxt) {",
	"           if (do_transit(t, EVENT_TRACE, 0))",
	"             uerror(\"non-determinism in event-trace\");",
	"         }",
	"",
	"         return;",
	"       }",
	"    }",
	"#ifdef NEGATED_TRACE",
	"  now._event = start_event; /* only 1st try will count */",
	"#else",
	"  depth ++;", 
	"  trpt ++;",
	"  uerror(\"event_trace error (no matching event)\");",
	"  trpt --;",
	"  depth --;",
	"#endif /* NEGATED_TRACE */",
	"}",
	"#endif /* EVENT_TRACE */\n\n",

	"int enabled(int iam, int pid)",
	"{",
	"  Trans *t; P *othis = this;",
	"  int res = 0; short tt; char ot;",
	"",
	"#ifdef VERI",
	"  if (pid > 0) pid++;",
	"#endif",
	"",
	"  if (pid == iam)",
	"    Uerror(\"used: enabled(pid=thisproc)\");",
	"",
	"  if (pid < 0 || pid >= (int) now._nr_pr)",
	"    return 0;",
	"",
	"  this = pptr(pid);",
	"  TstOnly = 1;",
	"  tt = (short)this->_p;",
	"  ot = (uchar)this->_t;",
	"",
	"  for (t = trans[(int)ot][(int)tt]; t; t = t->nxt)",
	"     if (do_transit(t, pid, 0)) {",
	"       res = 1;",
	"       break;",
	"  }",
	"",
	"  TstOnly = 0;",
	"  this = othis;",
	"  return res;",
	"}",
	"#endif /* INLINE */\n\n",

	"/* new_state() is the main search routine in the verifier",
	" * it has a lot of code ifdef-ed together to support",
	" * different search modes -- this makes it quite unreadable",
	" * of course.  if you are studying the code, first",
	" * let the C preprocessor generate a specific version",
	" * from the pan.c source, e.g. by saying:",
	" *	/lib/cpp -DNOREDUCE -DBITSTATE pan.c > Pan.c",
	" * and study the resulting file, rather than this one",
	" */",
	"",
	"void new_state(void)",
	"{",
	"  register Trans *t;",
	"  char n, m, ot, kk;",
	"  short II, JJ = 0, tt;\n",
	"  short From = now._nr_pr - 1, To = BASE;",
	"",
	"Down:",
	"  trpt->tau &= ~(16 | 32 | 64); /* make sure these are off */",
	"",
	"#if defined(FULLSTACK) && defined(MA)",
	"  trpt->proviso = 0;",
	"#endif",
	"",
	"  if (depth >= maxdepth)",
	"    {",
	"      truncs ++;",
	"#if SYNC",
	"      (trpt + 1)->o_n = 1; /* not a deadlock */",
	"#endif",
	"      if (!warned) {",
	"	 warned = 1;",
	"	 printf(\"error: max search depth too small\\n\");",
	"      }",
	"",
	"      (trpt - 1)->tau |= 16; /* worstcase guess */",
	"      goto Up;",
	"    }",
	"",
	"AllOver:",
	"#if defined(FULLSTACK) && !defined(MA)",
	"    trpt->ostate = (struct H_el *) 0;",
	"#endif",
	"#ifdef VERI",
	"    if ((trpt->tau&4) || ((trpt-1)->tau&128))",
	"#endif",
	"    if (boq == -1) {	/* if not mid-rv */",
	"#ifndef SAFETY",
	"      /* this check should now be redundant",
	"	* because the seed state also appears",
	"	* on the 1st dfs stack and would be",
	"       * matched in hstore below",
	"	*/",
	"	if ((now._a_t & 1) && depth > A_depth)"
	"         {",
	"           if (_statecmp(&A_Root, &now)) {",
	"	      depthfound = A_depth;",
	"#ifdef NP",
	"	      uerror(\"non-progress cycle\");",
        "#else",
	"             uerror(\"acceptance cycle\");",
	"#endif /* NP */",
	"             goto Up;",
	"         }",
	"    }",
	"#endif /* SAFETY */",
	"",
	"    if (!(trpt->tau & 8)) { /* if no atomic move */",
	"",
	"#ifdef CNTRSTACK",	/* -> bitstate, reduced, safety */
	"      _double_hash(&now);",
	"      trpt->j6 = j1;",
	"      trpt->j7 = j2;",
	"      JJ = LL[j1] && LL[j2];",
	"#endif /* CNTRSTACK */",
	"",
	"#ifdef FULLSTACK",
	"#ifdef BITSTATE",
	"      JJ = _onstack_now();",
	"#else",
	"#ifdef MA",
	"      II = _gstore(&now, 0);",
	"#else",
	"      II = _hstore(&now);",
	"#endif /* MA */",
	"      JJ = (II == 2) ? 1 : 0;",
	"#endif /* BITSTATE */",
	"#endif /* FULLSTACK */",
	"",
	"#ifdef BITSTATE",
	"#ifndef CNTRSTACK",	/* !reduced */
	"      _double_hash(&now);",
	"#endif",
	"      kk = II = ((SS[j2] & j3) && (SS[j1] & j4));",
	"#else",
	"#ifndef FULLSTACK",
	"#ifdef MA",
	"      JJ = II = _gstore(&now, 0);",
	"#else",
	"      II = _hstore(&now);",
	"#endif /* MA */",
	"#endif /* FULLSTACK */",
	"      kk = (II == 1 || II == 2);",
	"#endif /* BITSTATE */",
	"",
	"#ifdef DUMP",
	"      _statedump(&now);",
	"      printf(\"II=%%d (%%g)\\n\", II, nstates+truncs);",
	"#endif",
	"",
	"#ifndef SAFETY",
	"#if defined(FULLSTACK) && defined(BITSTATE)",
	"      if (!JJ && (now._a_t & 1) && depth > A_depth) {",
	"        int oj1 = j1;",
	"        uchar o_a_t = now._a_t;",
	"",
	"        now._a_t &= ~(1 | 16 | 32);",
	"",
	"        if (_onstack_now())",
	"          II = 3;",
	"",
	"        now._a_t = o_a_t;",
	"        j1 = oj1;",
	"      }",
	"#endif /* defined(FULLSTACK) && defined(BITSTATE) */",
	"",
	"      if (II == 3 && a_cycles && (now._a_t & 1)) {",
	"#ifndef NOFAIR",
	"	 if (fairness && now._cnt[1] != 0)",
	"          II = 0;",
	"	 else",
	"#endif /* NOFAIR */",
	"          {",
	"#ifdef BITSTATE",
	"            depthfound = Lstate->tagged - 1;",
	"#ifdef NP",
	"            uerror(\"non-progress cycle\");",
	"#else",
	"            uerror(\"acceptance cycle\");",
	"#endif /* NP */",
	"#else",
	"          depthfound = depth_of(Lstate);",
	"#ifdef NP",
	"          uerror(\"non-progress cycle\");",
	"#else",
	"	   uerror(\"acceptance cycle\");",
	"#endif /* NP */",
	"#endif /* BITSTATE */",
	"          goto Up;",
	"        }",
	"      }",
	"#endif /* SAFETY */",
	"",
	"#if !defined(FULLSTACK) && !defined(CNTRSTACK) && defined(BITSTATE)",
	"#ifndef NOREDUCE",
	"      JJ = II; /* worstcase guess for p.o. */",
	"#endif",
	"#endif /* !FULLSTACK && !CNTRSTACK && BITSTATE */",
	"",
	"#ifndef NOREDUCE",
	"#ifndef SAFETY",
	"      if ((II && JJ) || (II == 3)) {",
	"        /* marker for liveness proviso */",
	"        truncs2 ++;",
	"        (trpt - 1)->tau |= 16;",
	"      }",
	"#else",
	"      if (!II || !JJ)",
	"	 /* has successor outside stack */",
	"        (trpt - 1)->tau |= 64;",
	"#endif /* SAFETY */",
	"#endif /* NOREDUCE */",
	"",
	"      if (II) {",
	"        truncs ++;",
	"        goto Up;",
	"      }",
	"",
	"      if (!kk) {",
	"        nstates ++;",
	"",
	"        if ((unsigned long) nstates %% 1000000 == 0)",
	"          snapshot();",
	"#ifdef MA",
	"#ifdef W_XPT",
	"        if ((unsigned long) nstates %% W_XPT == 0)",
	"          w_xpoint();",
	"#endif /* W_XPT */",
	"#endif /* MA */",
	"      }",
	"",
	"#ifdef BITSTATE",
	"#ifdef RANDSTOR",
	"      if (rand() %% 100 <= RANDSTOR)",
	"#endif",
	"	 { SS[j2] |= j3; SS[j1] |= j4; }",
	"#endif /* BITSTATE */",
	"",
	"#if defined(FULLSTACK) || defined(CNTRSTACK)",
	"      _onstack_put();",
	"#endif /* FULLSTACK || CNTRSTACK */",
	"    }",	
	"    }",
	"",
	"    if (depth > mreached)",
	"      mreached = depth;",
	"",
	"#ifdef VERI",
	"    if (trpt->tau&4)",
	"#endif",
	"      trpt->tau &= ~(1|2);	/* timeout and -request off */",
	"    n = 0;",
	"#if SYNC",
	"    (trpt + 1)->o_n = 0;",
	"#endif",
	"",
	"#ifdef VERI",
	"    if (now._nr_pr == 0 || pptr(0)->_p == endclaim)",
	"      uerror(\"claim violated\");",
	"",
	"    if (stopstate[VERI][pptr(0)->_p])",
	"      uerror(\"endstate in claim reached\");",
	"",
	"Stutter:",
	"    if (trpt->tau & 4)	{ /* must make a claimmove */",
	"      II = 0;		  /* never */",
	"      goto Veri0;",
	"    }",
	"#endif /* VERI */",
	"",
	"#ifndef NOREDUCE",
	"    /* Look for a process with only safe transitions */",
	"    /* (special rules apply in the 2nd dfs) */",
	"#ifdef SAFETY",
	"    if (boq == -1 && From != To)",
	"#else",
	"    if (boq == -1 && From != To && (!(now._a_t & 1) || (a_cycles &&",
	"#ifndef BITSTATE",
	"#ifdef MA",
	"#ifdef VERI",
	"       !((trpt - 1)->proviso))",
	"#else",
	"       !(trpt->proviso))",
	"#endif /* VERI */",
	"#else",
	"#ifdef VERI",
	"       (trpt - 1)->ostate &&",
	"       !(((char *)&((trpt - 1)->ostate->state)) [0] & 128))",
	"#else",
	"       !(((char *)&(trpt->ostate->state))[0] & 128))",
	"#endif /* VERI */",
	"#endif /* MA */",
	"#else",
	"#ifdef VERI",
	"       (trpt - 1)->ostate && (trpt - 1)->ostate->proviso == 0)",
	"#else",
	"       trpt->ostate->proviso == 0)",
	"#endif /* VERI */",
	"#endif /* BITSTATE */",
	"       ))",
	"#endif /* SAFETY */",
	"    for (II = From; II >= To; II -= 1) {",
	"Resume:	/* pick up here if preselect fails */",
	"      this = pptr(II);",
	"      tt = (short)this->_p;",
	"      ot = (uchar)this->_t;",
	"",
	"      if (trans[(int)ot][(int)tt]->atom & 8)",
	"	 {",
	"          t = trans[(int)ot][(int)tt];",
	"",
	"          if (t->qu[0] != 0) {",
	"	     Ccheck ++;",
	"            if (!q_cond(II, t))",
	"	       continue;",
	"	     Cholds ++;",
	"	   }",
	"",
	"          From = To = II;",
	"#ifdef NIBIS",
	"          t->om = 0;",
	"#endif",
	"          trpt->tau |= 32; /* preselect marker */",
	"          goto Again;",
	"	 }",
	"    }",
	"",
	"    trpt->tau &= ~32;",
	"Again:",
	"#endif /* NOREDUCE */",
	"",
	"    /* The Main Expansion Loop over Processes */",
	"    trpt->o_pm &= ~(8|16|32|64); /* fairness-marks */",
	"",
	"#ifndef NOFAIR",
	"    if (fairness && boq == -1",
	"#ifdef VERI",
	"	&& (!(trpt->tau & 4) && !((trpt - 1)->tau & 128))",
	"#endif",
	"	&& !(trpt->tau & 8)) {",
	"         /* A_bit = 1; Cnt = N in acc states with A_bit 0 */",
	"         if (!(now._a_t & 2)) {",	/* A-bit not set */
	"	    if (a_cycles && (trpt->o_pm & 2)) { /* Accepting state */",
	"	      now._a_t |= 2;",
	"	      now._cnt[now._a_t & 1] = now._nr_pr + 1;", /* NEW +1 */
	"	      trpt->o_pm |= 8;",
	"	    }",
	"         }",
	"         else {",		/* A-bit set */
	"	    /* A_bit = 0 when Cnt 0 */",
	"	    if (now._cnt[now._a_t & 1] == 1) {",/* NEW: 1 iso 0 */
	"	      now._a_t &= ~2;",	        	/* reset a-bit */
	"	      now._cnt[now._a_t & 1] = 0;",	/* NEW: reset cnt */
	"	      trpt->o_pm |= 16;",
	"	    }",
	"         }",
	"    }",
	"#endif /* NOFAIR */",
	"",
	"    for (II = From; II >= To; II -= 1) {",
	"#if SYNC",
	"      /* no rendezvous with same proc */",
	"      if (boq != -1 && trpt->pr == II)",
	"        continue;",
	"#endif",
	"",
	"#ifdef VERI",
	"Veri0:",
	"#endif",
	"",
	"C999: /* function call-return entry point */",
	"      this = pptr(II);",
	"      tt = (short)this->_p;",
	"      ot = (uchar)this->_t;",
	"",
	"#ifdef NIBIS",
	"      /* don't repeat a previous preselected expansion */",
	"      /* could hit this if reduction proviso was false */",
	"      t = trans[(int)ot][(int)tt];",
	"",
	"      if (!(trpt->tau & 4)  && 	/* not claim */",
	"	   !(trpt->tau & 1)  && 	/* not timeout */",
	"	   !(trpt->tau & 32) && 	/* not preselected */",
	"	   (t->atom & 8)     && 	/* local */",
	"	   (boq == -1)       && 	/* not inside rendezvous */",
	"	   (From != To) {	        /* not inside atomic seq */",
	"	 if (t->qu[0] == 0   || 	/* unconditional */",
	"	     q_cond(II, t)) { 	        /* true condition */",
	"	   m = t->om;",
	"	   if (m > n || (n > 3 && m != 0))"
	"            n = m;",
	"	   continue; /* did it before */",
	"        }",	
	"      }",
	"#endif /* NIBIS */",
	"",
	"      trpt->o_pm &=  ~1; /* no move in this pid yet */",
	"#ifdef EVENT_TRACE",
	"      (trpt + 1)->o_event = now._event;",
	"#endif",
	"      /* Fairness: Cnt++ when Cnt == II */",
	"#ifndef NOFAIR",
	"      trpt->o_pm &= ~64; /* didn't apply rule 2 */",
	"",
	"      if (fairness",
	"	   && boq == -1",    /* not mid rv - except rcv - NEW 3.0.8*/
	"	   && !(trpt->o_pm & 32)",	/* Rule 2 not in effect */
	"	   && (now._a_t & 2)",	        /* A-bit is set */
	"	   &&  now._cnt[now._a_t & 1] == II + 2) {",
	"	  now._cnt[now._a_t & 1] -= 1;",
	"#ifdef VERI",
	"	  /* claim need not participate */",
	"	  if (II == 1)",
	"	    now._cnt[now._a_t&1] = 1;",
	"#endif /* VERI */",
	"         trpt->o_pm |= (32|64);",
	"      }",
	"#endif /* NOFAIR */",
	"",
	"#ifdef HAS_PROVIDED",
	"      if (!provided(II, ot, tt, t))",
	"        continue;",
	"#endif",
	"		/* check all trans of proc II - escapes first */",
	"#ifdef HAS_UNLESS",
	"      trpt->e_state = 0;",
	"#endif",
	"",
	"#ifdef EVENT_TRACE",
	"      (trpt + 1)->pr = II;",
	"#endif",
	"",
	"      for (t = trans[(int)ot][(int)tt]; t; t = t->nxt) {",
	"#ifdef HAS_UNLESS",
	"	 /* exploring all transitions from",
	"	  * a single escape state suffices",
	"	  */",
	"	  if (trpt->e_state > 0 &&  trpt->e_state != t->e_trans)",
	"	    break;",
	"#endif /* HAS_UNLESS */",
	"",
	"#ifdef EVENT_TRACE",
	"           (trpt + 1)->o_t = t;",
	"#endif",
	"",
	"#ifndef NOGC",
	"           (trpt + 1)->gc = 0;",
	"#ifdef GC0",
	"           (trpt + 1)->sv = 0;",
	"#endif /* GC0 */",
	"#endif /* NOGC */",
	"",
	"#ifdef INLINE",
	"#include \"pan.m\"",
	"#else",
	"	  if (!(m = do_transit(t, II, n)))"
	"           continue;",
	"#endif /* INLINE */",
	"P999:                     /* jumps here when move succeeds */",
	"	  if (boq == -1)",
	"#ifdef CTL",
	"	/* for branching-time, can accept reduction only if */",
	"	/* the persistent set contains just 1 transition */",
	"         {",
	"           if ((trpt->tau & 32) && (trpt->o_pm & 1))",
	"	      trpt->tau |= 16;",
	"",
	"	    trpt->o_pm |= 1; /* we moved */",
	"	  }",
	"#else",
	"	  trpt->o_pm |= 1; /* we moved */",
	"#endif /* CTL */",
	"",
	"#ifdef PEG",
	"	  peg[t->forw] ++;",
	"#endif",
	"",
	"#ifdef HAS_LAST",
	"#ifdef VERI",
	"	  if (II != 0)",
	"#endif",
	"	    now._last = II - BASE;",
	"#endif /* HAS_LAST */",
	"",
	"#ifdef HAS_UNLESS",
	"	  trpt->e_state = t->e_trans;",
	"#endif",
	"",
	"         depth ++;", 
	"         trpt ++;",
	"         trpt->pr = II;",
	"         trpt->st = tt;",
	"         trpt->o_pm &= ~(2|4);",
	"         trpt->rt = rt[II];",
	"         trpt->vt = vt[II];",
	"",
	"         if (!vt[II] && t->st > 0)",
	"	    this->_p = t->st;",
	"",
	"#ifndef SAFETY",
	"	 if (a_cycles) {",
	"#define PQ	pptr(ii)",
	"#if ACCEPT_LAB > 0",
	"#ifdef NP",

	"            /* state 1 of np_ claim is accepting */",
	"	     if (pptr(0)->_p == 1)",
	"	       trpt->o_pm |= 2;",
	"#else",
	"          {",
	"	     register int ii;",
	"	     for (ii = 0; ii < (int) now._nr_pr; ii ++) {",
	"	       if (accpstate[PQ->_t][PQ->_p]) {",
	"	         trpt->o_pm |= 2;",
	"	         break;",
	"	       }",
        "            }",
	"          }",
	"#endif /* NP */",
	"#endif /* ACCEPT_LAB */",
	"",
	"#if defined(HAS_NP) && PROG_LAB > 0",
	"            for (ii = 0; ii < (int) now._nr_pr; ii ++) {",
	"	       if (progstate[PQ->_t][PQ->_p]) {",
	"	         trpt->o_pm |= 4;",
	"	         break;",
	"	       }"
	"            }",
	"#endif",
	"#undef PQ",
	"         }",
	"#endif /* SAFETY */",
	"         trpt->o_t  =  t; trpt->o_n  = n;",
	"	  trpt->o_ot = ot; trpt->o_tt = tt;",
	"	  trpt->o_To = To; trpt->o_m  = m;",
	"	  trpt->tau = 0;",
	"",
	"	  if (boq != -1 || (t->atom & 2)) {",
	"	     trpt->tau |= 8;",
	"#ifdef VERI",
	"	      /* atomic sequence in claim */",
	"	     if ((trpt - 1)->tau & 4)",
	"	        trpt->tau |= 4;",
	"	     else",
	"	        trpt->tau &= ~4;",
	"	     }",
	"            else {",
	"	        if ((trpt - 1)->tau & 4)",
	"	           trpt->tau &= ~4;",
	"	        else",
	"	           trpt->tau |= 4;",
	"	     }",
	"",
	"	     /* if claim allowed timeout, so */",
	"	     /* does the next program-step: */",
	"	     if (((trpt - 1)->tau & 1) && !(trpt->tau & 4))",
	"	        trpt->tau |= 1;",
	"#else",
	"	 } else",
	"	     trpt->tau &= ~8;",
	"#endif /* VERI */",
	"	  if (boq == -1 && (t->atom & 2)) {",
	"	     From = To = II;", 
	"            nlinks++;",
	"	  }",
	"         else {",
	"	     From = now._nr_pr - 1;",
	"            To = BASE;",
	"	  }",
	"",
	"         if (vt[II]) {",
	"           vt[II] = 0;",
	"           goto C999;",
	"         }",
	"",
	"         rt[II] = 0;",
	"	  goto Down;	/* pseudo-recursion */",
	"Up:",
	"#ifdef MA",
	"	 if (depth <= 0)",
	"          return;",
	"	/* e.g., if first state is old, after a restart */",
	"#endif /* MA */",
	
	"#ifndef NOFAIR",
	"        if (trpt->o_pm & 128) { /* fairness alg */",
	"	   now._cnt[now._a_t & 1] = trpt->oval;",
	"	   n = 1;",
	"          trpt->o_pm &= ~128;",
	"	   if (vt[II]) depth --;",
	"          trpt --;",
	"	   goto Q999;",
	"        }",
	"#endif /* NOFAIR */",
	"",
	"#ifdef HAS_LAST",
	"#ifdef VERI",
	"        {", 
	"          int d;",
	"	   now._last = 0;",
	"	   for (d = 1; d < depth; d++) {",
	"	      if ((trpt - d)->pr != 0) {",
	"		now._last = (trpt - d)->pr - BASE;",
	"		break;",
	"	       }", 
	"          }",
        "        }",
	"#else",
	"	 now._last = (depth < 1) ? 0 : (trpt - 1)->pr;",
	"#endif /* VERI */",
	"#endif /* HAS_LAST */",
	"",
	"#ifdef EVENT_TRACE",
	"        now._event = trpt->o_event;",
	"#endif",
	"",
	"#ifndef SAFETY",
	"	 if ((now._a_t & 1) && depth <= A_depth)",
	"	   return;	/* to checkcycles() */",
	"#endif",
	"",
	"        t  = trpt->o_t;   n    = trpt->o_n;",
	"        ot = trpt->o_ot;  II   = trpt->pr;",
	"        tt = trpt->o_tt;  this = pptr(II);",
	"        To = trpt->o_To;  m    = trpt->o_m;",
	"",
	"        vt[II] = trpt->vt;",
	"        rt[II] = trpt->rt;",
	"",
	"#ifdef INLINE_REV",
	"	 m = do_reverse(t, II, m);",
	"#else",
	"#include \"pan.b\"",
	"R999:	 /* jumps here when done */",
	"#endif",
	"",
	"#ifndef NOREDUCE",
	"	 /* pass the proviso tags */",
	"	 if ((trpt->tau & 8) &&	/* rv or atomic */",
	"	     (trpt->tau & 16))",
	"	   (trpt - 1)->tau |= 16;",
	"#ifdef SAFETY",
	"	 if ((trpt->tau & 8) &&	/* rv or atomic */",
	"	     (trpt->tau & 64))",
	"	   (trpt - 1)->tau |= 64;",
	"#endif /* SAFETY */",
	"#endif /* NOREDUCE */",
	"	 depth--; trpt--;",
	"#ifdef NIBIS",
	"	 (trans[(int)ot][(int)tt])->om = m; /* head of list */",
	"#endif /* NIBIS */",
	"",
	"	 /* i.e., not set if rv fails */",
	"	 if (m) reached[(int)ot][(int)t->st] = 1;",
	"",
	"	 if (m > n || (n > 3 && m != 0))",
	"          n = m;",
	"",
	"	 this->_p = tt;",
	"      } /* all options */",
	"#ifndef NOFAIR",
	"      /* Fairness: undo Rule 2 */",
	"      if ((trpt->o_pm & 32) &&",/* rule 2 was applied */
	"	   (trpt->o_pm & 64)) {",/* by this process II */
	"	  if (trpt->o_pm & 1) {",/* it didn't block */
	"#ifdef VERI",
	"	     if (now._cnt[now._a_t & 1] == 1)",	/* NEW: 1 iso 0 */
	"	        now._cnt[now._a_t & 1] = 2;",	/* NEW: 2 iso 1*/
	"#endif",
	"	     now._cnt[now._a_t & 1] += 1;",
	"	     trpt->o_pm &= ~(32|64);",
	"	  }",
	"         else { /* process blocked  */",	
	"	    if (n > 0) {", /* a prev proc didn't */
	"	       trpt->o_pm &= ~64;",
	"	       II = From + 1;",
	"	    }",	
	"         }",
	"      }",
	"#endif /* NOFAIR */",
	"",
	"#ifdef VERI",
	"      if (II == 0) break;	/* never claim */",
	"#endif",
	"    } /* all processes */",
	"",
	"#ifndef NOFAIR",
	"    /* Fairness: undo Rule 2 */",
	"    if (trpt->o_pm & 32) {	/* remains if proc blocked */",
	"#ifdef VERI",
	"      if (now._cnt[now._a_t & 1] == 1)",	/* NEW: 1 iso 0 */
	"	 now._cnt[now._a_t & 1] = 2;",  	/* NEW: 2 iso 1 */
	"#endif",
	"      now._cnt[now._a_t & 1] += 1;",
	"      trpt->o_pm &= ~32;",
	"    }",
	"#ifndef NP",
	/* 12/97 non-progress cycles cannot be created
	 * by stuttering extension, here or elsewhere
	 */
	"    if (fairness ",
	"	 && n == 0              /* nobody moved */",
	"#ifdef VERI",
	"       && !(trpt->tau & 4)	/* in program move */",
	"#endif",
	"	&& !(trpt->tau & 8) 	/* not an atomic one */",
	"#ifdef OTIM",
	"       && ((trpt->tau & 1) || endstate())",
	"#else",
	"#ifdef ETIM",
	"	&&  (trpt->tau & 1)	/* already tried timeout */",
	"#endif",
	"#endif /* OTIM */",
	"#ifndef NOREDUCE",
	"	&& !((trpt->tau & 32) && (n == 0 || (trpt->tau & 16)))",
	"#endif",
	"	&& now._cnt[now._a_t & 1] > 0)	{ /* needed more procs */",
	"      depth ++;",
	"      trpt ++;",
	"      trpt->o_pm |= 128 | ((trpt - 1)->o_pm & (2|4));",
	"      trpt->oval = now._cnt[now._a_t & 1];",
	"      now._cnt[now._a_t & 1] = 0;",
	"#ifdef VERI",
	"      trpt->tau = 4;",
	"#else",
	"      trpt->tau = 0;",
	"#endif",
	"      From = now._nr_pr - 1; To = BASE;",
	"      goto Down;",
	"    }",
	"#endif /* NP */",
	"Q999:	/* returns here with n > 0 when done */;",
	"    if (trpt->o_pm & 8) {",
	"      now._a_t &= ~2;",
	"      now._cnt[now._a_t & 1] = 0;",
	"      trpt->o_pm &= ~8;",
	"    }",
	"",
	"    if (trpt->o_pm & 16) {",
	"      now._a_t |= 2;",		/* restore a-bit */
	"      now._cnt[now._a_t & 1] = 1;",	/* NEW: restore cnt */
	"      trpt->o_pm &= ~16;",
	"    }",
	"#endif /* NOFAIR */",
	"",
	"#ifndef NOREDUCE",
	"#ifdef SAFETY",
	"    /* preselected move - no successors outside stack */",
	"    if ((trpt->tau & 32) && !(trpt->tau & 64)) {",
	"      From = now._nr_pr-1; To = BASE;",
	"      n = 0; trpt->tau &= ~(16|32|64);",
	"",
	"      if (II >= BASE)	/* II already decremented */",
	"	 goto Resume;",
	"      else",
	"	 goto Again;",
	"    }",
	"#else /* SAFETY */",
	"    /* at least one move that was preselected at this */",
	"    /* level, blocked or truncated at the next level  */",
	"    /* implied: #ifdef FULLSTACK */",
	"    if ((trpt->tau & 32) && (n == 0 || (trpt->tau & 16))) {",
	"      if (a_cycles && (trpt->tau & 16)) {",
	"	 if (!(now._a_t & 1)) {",
	"#ifndef BITSTATE",
	"#ifdef MA",
	"#ifdef VERI",
	"	   (trpt - 1)->proviso = 1;",
	"#else",
	"	   trpt->proviso = 1;",
	"#endif /* VERI */",
	"#else",
	"#ifdef VERI",
	"	   if ((trpt - 1)->ostate)",
	"	     ((char *)&((trpt - 1)->ostate->state)) [0] |= 128;",
	"#else",
	"	   ((char *)&(trpt->ostate->state))[0] |= 128;",
	"#endif /* VERI */",
	"#endif /* MA */",
	"#else  /* BITSTATE */",
	"#ifdef VERI",
	"	   if ((trpt - 1)->ostate)",
	"	     (trpt-1)->ostate->proviso = 1;",
	"#else",
	"	   trpt->ostate->proviso = 1;",
	"#endif",
	"#endif /* BITSTATE */",
	"	   From = now._nr_pr - 1; To = BASE;",
	"	   n = 0; trpt->tau &= ~(16|32|64);",
	"	   goto Again; /* do full search */",
	"	 } /* else accept reduction */",
	"      }",
	"      else {",
	"	   From = now._nr_pr - 1; To = BASE;",
	"	   n = 0; trpt->tau &= ~(16|32|64);",
	"",
	"	   if (II >= BASE)	/* already decremented */",
	"	     goto Resume;",
	"	   else",
	"	     goto Again;",
	"      }",
	"    }",
	"#endif /* SAFETY */",
	"#endif /* NOREDUCE */",
	"",
	"    if (n == 0 || ((trpt->tau & 4) && (trpt->tau & 2))) {",
	"#if SYNC",
	"      /* ok if a rendez-vous fails: */",
	"      if (boq != -1) goto Done;",
	"#endif",
	"      /* ok if no procs or we're at maxdepth */",
	"      if (now._nr_pr == 0",
	"#ifdef OTIM",
	"	   || endstate()",
	"#endif",
	"	   || depth >= maxdepth - 1)",
	"        goto Done;",
	"/* new location of atomic block code -- BEFORE timeout */",
	"      if ((trpt->tau & 8) && !(trpt->tau & 4)) {",
	"	 trpt->tau &= ~(1|8);",
	"	 /* 1=timeout, 8=atomic */",
	"	 From = now._nr_pr - 1; To = BASE;",
	"#ifdef VERI",
	"	 trpt->tau |= 4;	/* switch to claim */",
	"#endif",
	"	 goto AllOver;",
	"      }",
	"#ifdef ETIM",
	"      if (!(trpt->tau & 1))", /* didn't try timeout yet */
	"        {",
	"#ifdef VERI",
	"	   if (trpt->tau & 4)",
	"            {",
	"#ifndef NTIM",
	"	       if (trpt->tau & 2)", /* requested */
	"#endif",
	"                {",
	"	           trpt->tau |=  1;",
	"	           trpt->tau &= ~2;",
	"	           goto Stutter;",
	"	         }",
	"            }",
	"        }"
	"      else {",
	"        /* only claim can enable timeout */",
	"	 if ((trpt->tau & 8) && !((trpt-1)->tau & 4))",
	"        /* blocks inside an atomic */",
	"          goto BreakOut;",
	"",
	"	 (trpt - 1)->tau |= 2; /* request */",
	"	 goto Up;",
	"      }",
	"#else",
	"      trpt->tau |=  1;",
	"      goto Again;",
	"#endif /* VERI */",
	"    }",
	/* old location of atomic block code */
	"BreakOut:",
	"#endif /* ETIM */",
	"",
	"#ifdef VERI",
	"#ifndef NOSTUTTER",
	"    if (!(trpt->tau & 4))",
	"      {",
	"	 trpt->tau |= 4;   /* claim stuttering */",
	"	 trpt->tau |= 128; /* stutter mark */",
	"	 goto Stutter;",
	"      }",
	"#endif /* NOSTUTTER */",
	"#else",
	"    if (!noends && !a_cycles && !endstate())",
	"      uerror(\"invalid endstate\");",
	"#endif /* VERI */",
	"    }",
	"",
	"Done:",
	"    if (!(trpt->tau & 8))	/* not in atomic seqs */",
	"      {",
	"#ifndef SAFETY",
	"	 if (n != 0",		/* we made a move */
	"#ifdef VERI",
	"	 /* --after-- a program-step, i.e., */",
	"	 /* after backtracking a claim-step */",
	"	     && (trpt->tau & 4)",
	"#endif /* VERI */",
	"	     && !(now._a_t & 1)) {",	/* not in 2nd DFS */
	"#ifndef NOFAIR",
	"	     if (fairness) {",
	"	       if ((now._a_t & 2) /* A-bit */",
	"		   && (now._cnt[0] == 1))",
	"		 checkcycles();",
	"	     } else",
	"#endif /* NOFAIR */",
	"	     if (a_cycles && (trpt->o_pm & 2))",
	"	       checkcycles();",
	"        }",
	"#endif /* SAFETY */",
	"",
	"  if (!trpt->vt)",
	"#ifndef MA",
	"#if defined(FULLSTACK) || defined(CNTRSTACK)",
	"#ifdef VERI",
	"	 if (boq == -1",
	"            && (((trpt->tau & 4)",
	"            && !(trpt->tau & 128))",
	"            || ((trpt - 1)->tau & 128))) {",
	"#else",
	"        if (boq == -1) {",
	"#endif /* VERI */",
	"	   _onstack_zap();",
	"	 }",
	"#endif /* FULLSTACK || CNTRSTACK */",
	"#else",
	"#ifdef VERI",
	"	 if (boq == -1",
	"            && (((trpt->tau & 4)",
	"            && !(trpt->tau & 128))",
	"            || ((trpt - 1)->tau & 128))) {",
	"#else",
	"        if (boq == -1) {",
	"#endif /* VERI */",
	"            _onstack_zap();",
	"#ifndef NOREDUCE",
	"        if (trpt->proviso)",
	"           _gstore(&now, 1);",
	"#endif",
	"	}",
	"#endif /* MA */",
	"  }",
	"",
	"  if (depth > 0)",
	"    goto Up;",
	"}\n\n",

	"#ifndef SAFETY",
	"void checkcycles(void)",
	"{",
	"  uchar o_a_t = now._a_t;",
	"#ifdef FULLSTACK",
	"#ifndef MA",
	"  struct H_el *sv = trpt->ostate; /* save */",
	"#else",
	"  uchar prov = trpt->proviso; /* save */",
	"#endif /* MA */",
	"#endif /* FULLSTACK */",
	"",
	"  now._a_t |= (1|16|32);",
	"  /* 1 = 2nd DFS; (16|32) to help hasher */",
	"#ifndef NOFAIR",
	"  now._cnt[1] = now._cnt[0];",
	"#endif /* NOFAIR */",
	"  _statecpy(&A_Root, &now);",
	"  A_depth = depthfound = depth;",
	"  new_state();	/* start 2nd DFS */",
	"  now._a_t = o_a_t;",
	"  A_depth = 0; depthfound = -1;",
	"",
	"#ifdef FULLSTACK",
	"#ifndef MA",
	"  trpt->ostate = sv;	/* restore */",
	"#else",
	"  trpt->proviso = prov;",
	"#endif /* MA */",
	"#endif /* FULLSTACK */",
	"}",
	"#endif /* SAFETY */\n\n",

	"#include \"pan.t\"\n\n",

	"void do_reach(void)",
	"{",
	0,
};
