/***** spin: pangen2.h *****/

/* Copyright (c) 1991-1998 by Lucent Technologies - Bell Laboratories     */
/* All Rights Reserved.  This software is for educational purposes only.  */
/* Permission is given to distribute this code provided that this intro-  */
/* ductory message is not removed and no monies are exchanged.            */
/* No guarantee is expressed or implied by the distribution of this code. */
/* Software written by Gerard J. Holzmann as part of the book:            */
/* `Design and Validation of Computer Protocols,' ISBN 0-13-539925-4,     */
/* Prentice Hall, Englewood Cliffs, NJ, 07632.                            */
/* Send bug-reports and/or questions to: gerard@research.bell-labs.com    */

/* dSpin extension written by Radu Iosif. Feedback: iosif@athena.polito.it */


static char *Preamble[] = {
	"#include <stdio.h>",
	"#include <signal.h>",
	"#include <stdlib.h>",
	"#include <string.h>",
	"#include <strings.h>",	/* doug says so */
	"",
	"#include \"pan.h\"",
	"",
	"#ifdef VAR_RANGES",
	"void logval(char *, int);",
	"void dumpranges(void);",
	"#endif",
	"",
	"void active_procs(void);",
	"void cleanup(void);",
	"void do_the_search(void);",
	"void find_shorter(int);",
	"void iniglobals(void);",
	"",
	0,
};

static char *Tail[] = {
	"Trans *",
	"settr(	int t_id, int a, int b, int c, int d,",
	"	char *t, int g, int tpe0, int tpe1)",
	"{	Trans *tmp = (Trans *) emalloc(sizeof(Trans));\n",
	"	tmp->atom  = a&(6|32);	/* only (2|8|32) have meaning */",
	"	if (!g) tmp->atom |= 8;	/* no global references */",
	"	tmp->st    = b;",
	"	tmp->tpe[0] = tpe0;",
	"	tmp->tpe[1] = tpe1;",
	"	tmp->tp    = t;",
	"	tmp->t_id  = t_id;",
	"	tmp->forw  = c;",
	"	tmp->back  = d;",
	"	return tmp;",
	"}\n",
	"Trans *",
	"cpytr(Trans *a)",
	"{	Trans *tmp = (Trans *) emalloc(sizeof(Trans));\n",
	"	int i;",
	"	tmp->atom  = a->atom;",
	"	tmp->st    = a->st;",
	"#ifdef HAS_UNLESS",
	"	tmp->e_trans = a->e_trans;",
	"	for (i = 0; i < HAS_UNLESS; i++)",
	"		tmp->escp[i] = a->escp[i];",
	"#endif",
	"	tmp->tpe[0] = a->tpe[0];",
	"	tmp->tpe[1] = a->tpe[1];",
	"	for (i = 0; i < 6; i++)",
	"	{	tmp->qu[i] = a->qu[i];",
	"		tmp->ty[i] = a->ty[i];",
	"	}",
	"	tmp->tp    = (char *) emalloc(strlen(a->tp)+1);",
	"	strcpy(tmp->tp, a->tp);",
	"	tmp->t_id  = a->t_id;",
	"	tmp->forw  = a->forw;",
	"	tmp->back  = a->back;",
	"	return tmp;",
	"}\n",
	"#ifndef NOREDUCE",
	"int",
	"srinc_set(int n)",
	"{	if (n <= 2) return LOCAL;",
	"	if (n <= 2+  DELTA) return Q_FULL_F; /* 's' or nfull  */",
	"	if (n <= 2+2*DELTA) return Q_EMPT_F; /* 'r' or nempty */",
	"	if (n <= 2+3*DELTA) return Q_EMPT_T; /* empty */",
	"	if (n <= 2+4*DELTA) return Q_FULL_T; /* full  */",
	"	if (n ==   5*DELTA) return GLOBAL;",
	"	if (n ==   6*DELTA) return TIMEOUT_F;",
	"	if (n ==   7*DELTA) return ALPHA_F;",
	"	Uerror(\"cannot happen srinc_class\");",
	"	return BAD;",
	"}",
	"int",
	"srunc(int n, int m)",
	"{	switch(m) {",
	"	case Q_FULL_F: return n-2;",
	"	case Q_EMPT_F: return n-2-DELTA;",
	"	case Q_EMPT_T: return n-2-2*DELTA;",
	"	case Q_FULL_T: return n-2-3*DELTA;",
	"	case ALPHA_F:",
	"	case TIMEOUT_F: return 257; /* non-zero, and > MAXQ */",
	"	}",
	"	Uerror(\"cannot happen srunc\");",
	"	return 0;",
	"}",
	"#endif\n\n",
	"int cnt;\n",
	"void retrans(int n, int m, int is, short srcln[], uchar reach[])",
	"/* process n, with m states, is=initial state */",
	"{",
	"  Trans *T0, *T1, *T2, *T3;",
	"  int i;",
	"#ifndef NOREDUCE",
	"  int j, k, p, h, g, aa;",
	"#endif",
	"  if (state_tables >= 4) {",
	"    printf(\"STEP 1 proctype %%s\\n\", procname[n]);",
	"    for (i = 1; i < m; i ++)",
	"    for (T0 = trans[n][i]; T0; T0 = T0->nxt)",
	"      crack(n, i, T0, srcln);",
	"    return;",
	"  }",
	"  do {",
	"    for (i = 1, cnt = 0; i < m; i ++) {",
	"      T2 = trans[n][i];",
	"      T1 = T2 ? T2->nxt : (Trans *)0;",
	"      for (T0 = T1; T0; T0 = T0->nxt) {",
	"        if (T0->st &&  trans[n][T0->st]->nxt)",
	"	   break;",
	"      }",
	"",
	"    if (T0)",
	"      for (T0 = T1; T0; T0 = T0->nxt) {",
	"	 T3 = trans[n][T0->st];",
	"	 if (!T3->nxt) {",
	"	   T2->nxt = cpytr(T0);",
	"	   T2 = T2->nxt;",
	"	   imed(T2, T0->st, n);",
	"	   continue;",
	"	 }",
	"",
	"        do {",
	"          T3 = T3->nxt;",
	"	   T2->nxt = cpytr(T3);",
	"	   T2 = T2->nxt;",
	"	   imed(T2, T0->st, n);",
	"	 } while (T3->nxt);",
	"",
	"	 cnt++;",
	"      }",
	"    }",
	"  } while (cnt);",
	"",
	"  if (state_tables >= 3) {",
	"    printf(\"STEP 2 proctype %%s\\n\", procname[n]);",
	"    for (i = 1; i < m; i ++)",
	"      for (T0 = trans[n][i]; T0; T0 = T0->nxt)",
	"	 crack(n, i, T0, srcln);",
	"      return;",
	"  }",
	"",
	"  for (i = 1; i < m; i ++) {",
	"    if (trans[n][i] && trans[n][i]->nxt) { /* optimize */",
	"      T1 = trans[n][i]->nxt;",
	"      T0 = cpytr(trans[n][T1->st]);",
	"      trans[n][i] = T0;",
	"      reach[T1->st] = 1;",
	"      imed(T0, T1->st, n);",
	"",
	"      for (T1 = T1->nxt; T1; T1 = T1->nxt) {",
	"	 T0->nxt = cpytr(trans[n][T1->st]);",
	"	 T0 = T0->nxt;",
	"	 reach[T1->st] = 1;",
	"	 imed(T0, T1->st, n);",
	"	}",
	"    }",
	"  }",
	"",
	"  if (state_tables >= 2) {",
	"    printf(\"STEP 3 proctype %%s\\n\", procname[n]);",
	"    for (i = 1; i < m; i ++)",
	"      for (T0 = trans[n][i]; T0; T0 = T0->nxt)",
	"	 crack(n, i, T0, srcln);",
	"    return;",
	"  }",
	"",
	"#ifdef HAS_UNLESS",
	"  for (i = 1; i < m; i ++) {",
	"    if (!trans[n][i]) continue;",
	"    /* check for each state i if an",
	"     * escape to some state p is defined",
	"     * if so, copy and mark p's transitions",
	"     * and prepend them to the transition-",
	"     * list of state i",
	"     */",
	"    for (T0 = trans[n][i]; T0; T0 = T0->nxt)",
	"      for (k = HAS_UNLESS - 1; k >= 0; k --) {",
	"	 if ((p = T0->escp[k]))",
	"	   for (T1 = trans[n][p]; T1; T1 = T1->nxt) {",
	"	     T2 = cpytr(T1);",
	"	     T2->e_trans = p;",
	"	     T2->nxt = trans[n][i];",
	"	     trans[n][i] = T2;",
	"	   }",
	"      }",
	"  }",
	"#endif /* HAS_UNLESS */",
	"",
	"#ifndef NOREDUCE",
	"  for (i = 1; i < m; i ++) {",
	"    if (a_cycles) {",
	"    /* moves through these states are visible */",
	"#if PROG_LAB > 0 && defined(HAS_NP)",
	"      if (progstate[n][i])",
	"	 goto degrade;",
	"",
	"      for (T1 = trans[n][i]; T1; T1 = T1->nxt)",
	"	 if (progstate[n][T1->st])",
	"	   goto degrade;",
	"#endif",
	"      if (accpstate[n][i] || visstate[n][i])",
	"	   goto degrade;",
	"",
	"      for (T1 = trans[n][i]; T1; T1 = T1->nxt)",
	"	   if (accpstate[n][T1->st])",
	"	     goto degrade;",
	"    }",
	"",
	"    T1 = trans[n][i];",
	"    if (!T1) continue;",
	"    /* check if mixing of guards preserves reduction */",
	"    if (T1->nxt) {",
	"      k = 0;",
	"      for (T0 = T1; T0; T0 = T0->nxt) {",
	"	 if (!(T0->atom & 8))",
	"	   goto degrade;",
	"",
	"	 for (aa = 0; aa < 2; aa ++) {",
	"	   if (srinc_set(T0->tpe[aa]) >=  GLOBAL)",
	"	     goto degrade;",
	"",
	"	   if (T0->tpe[aa] && T0->tpe[aa] !=  T1->tpe[0])",
	"	     k = 1;",
	"	 }",
        "      }",
	"",
	"      g = 0;",
	"",
	"      if (k)	/* non-uniform selection */",
	"	 for (T0 = T1; T0; T0 = T0->nxt)",
	"	   for (aa = 0; aa < 2; aa++) {",
	"	     j = srinc_set(T0->tpe[aa]);",
	"",
	"	     if (j != LOCAL) {",
	"	       k = srunc(T0->tpe[aa], j);",
	"",
	"	       for (h = 0; h < 6; h ++)",
	"	         if (T1->qu[h] == k && T1->ty[h] == j)",
	"		   break;",
	"",
	"	       if (h >= 6) {",
	"	         T1->qu[g%%6] = k;",
	"	         T1->ty[g%%6] = j;",
	"	         g ++;",
	"	       }",
	"            }",
	"          }",
	"",
	"	   if (g > 6) {",
	"	     T1->qu[0] = 0;	/* turn it off */",
	"#if 1",
	"				printf(\"line %%d, \", srcln[i]);",
	"			 	printf(\"too many types (%%d)\",",
	"					g);",
	"			  	printf(\" in selection\\n\");",
	"#endif",
	"			  goto degrade;",
	"			}",
	"		}",
	"		/* mark all options global if >=1 is global */",
	"		for (T1 = trans[n][i]; T1; T1 = T1->nxt)",
	"			if (!(T1->atom&8)) break;",
	"		if (T1)",
	"degrade:	for (T1 = trans[n][i]; T1; T1 = T1->nxt)",
	"			T1->atom &= ~8;",

	"		/* can only mix 'r's or 's's if on same chan */",
	"		/* and not mixed with other local operations */",
	"		T1 = trans[n][i]; j = T1->tpe[0];",

	"		if (T1->qu[0]) continue;",

	"		if (T1->nxt && T1->atom&8)",
	"		{ if (j == 5*DELTA)",
	"		  {",
	"#if 1",
	"			printf(\"warning: line %%d \", srcln[i]);",
	"			printf(\"mixed condition \");",
	"			printf(\"(defeats reduction)\\n\");",
	"#endif",
	"			goto degrade;",
	"		  }",
	"		  for (T0 = T1; T0; T0 = T0->nxt)",
	"		  for (aa = 0; aa < 2; aa++)",
	"		  if  (T0->tpe[aa] && T0->tpe[aa] != j)",
	"		  {",
	"#if 1",
	"			printf(\"warning: line %%d \", srcln[i]);",
	"			printf(\"[%%d-%%d] mixed %%stion \",",
	"				T0->tpe[aa], j, ",
	"				(j==5*DELTA)?\"condi\":\"selec\");",
	"			printf(\"(defeats reduction)\\n\");",
	"			printf(\"	'%%s' <-> '%%s'\\n\",",
	"				T1->tp, T0->tp);",
	"#endif",
	"			goto degrade;",
	"		} }",
	"	}",
	"#endif",
	"	if (state_tables)",
	"	{	printf(\"proctype \");",
	"		if (!strcmp(procname[n], \":init:\"))",
	"			printf(\"init\\n\");",
	"		else",
	"			printf(\"%%s\\n\", procname[n]);",
	"		for (i = 1; i < m; i++)",
	"			reach[i] = 1;",
	"		tagtable(n, m, is, srcln, reach);",
	"	} else",
	"	for (i = 1; i < m; i++)",
	"	{	int nrelse;",
	"		if (strcmp(procname[n], \":never:\") != 0)",
	"		for (T0 = trans[n][i]; T0; T0 = T0->nxt)",
	"		{	if (T0->st == i",
	"			&& strcmp(T0->tp, \"(1)\") == 0)",
	"			{	printf(\"error: proctype '%%s' \",",
	"					procname[n]);",
	"		  		printf(\"line %%d, state %%d: has un\",",
	"					srcln[i], i);",
	"				printf(\"conditional self-loop\\n\");",
	"				exit(1);",
	"		}	}",
	"		nrelse = 0;",
	"		for (T0 = trans[n][i]; T0; T0 = T0->nxt)",
	"		{	if (strcmp(T0->tp, \"else\") == 0)",
	"				nrelse++;",
	"		}",
	"		if (nrelse > 1)",
	"		{	printf(\"error: proctype '%%s' state\",",
	"				procname[n]);",
	"		  	printf(\" %%d, inherits %%d\", i, nrelse);",
	"		  	printf(\" 'else' stmnts\\n\");",
	"			exit(1);",
	"	}	}",
	"}\n",
	"void",
	"imed(Trans *T, int v, int n)	/* set intermediate state */",
	"{	progstate[n][T->st] |= progstate[n][v];",
	"	accpstate[n][T->st] |= accpstate[n][v];",
	"	stopstate[n][T->st] |= stopstate[n][v];",
	"}\n\n",

	"void tagtable(int n, int m, int is, short srcln[], uchar reach[])",
	"{",
	"  Trans *z;\n",
	"  if (is >= m || !trans[n][is]",
	"      || is <= 0 || reach[is] == 0)",
	"  return;",
	"",
	"  reach[is] = 0;",
	"",
	"  if (state_tables)",
	"    for (z = trans[n][is]; z; z = z->nxt)",
	"      crack(n, is, z, srcln);",
	"",
	"  for (z = trans[n][is]; z; z = z->nxt) {",
	"#ifdef HAS_UNLESS",
	"    int i, j;\n",
	"#endif",
	"    tagtable(n, m, z->st, srcln, reach);",
	"#ifdef HAS_UNLESS",
	"    for (i = 0; i < HAS_UNLESS; i ++) {",
	"      j = trans[n][is]->escp[i];",
	"      if (!j) break;",
	"      tagtable(n, m, j, srcln, reach);",
	"    }",
	"#endif /* HAS_UNLESS */",
	"  }",
	"}\n\n",
	"void",
	"crack(int n, int j, Trans *z, short srcln[])",
	"{	int i;\n",
	"	if (!z) return;",
#if 0
	"	printf(\"\tstate %%3d --[%%3d]-->\",",
	"		j, z->forw);",
#else
	"	printf(\"\tstate %%3d -(tr %%3d)-> state %%3d  \",",
	"		j, z->forw, z->st);",
	"	printf(\"[id %%3d tp %%3d\", z->t_id, z->tpe[0]);",
	"	if (z->tpe[1]) printf(\",%%d\", z->tpe[1]);",
	"#ifdef HAS_UNLESS",
	"	if (z->e_trans)",
	"		printf(\" org %%3d\", z->e_trans);",
	"	else if (state_tables >= 2)",
	"	for (i = 0; i < HAS_UNLESS; i++)",
	"	{	if (!z->escp[i]) break;",
	"		printf(\" esc %%d\", z->escp[i]);",
	"	}",
	"#endif",
	"	printf(\"]\");",
#endif
	"	printf(\" [%%s%%s%%s%%s%%s] line %%d => \",",
	"		z->atom&6?\"A\":z->atom&32?\"D\":\"-\",",
	"		accpstate[n][j]?\"a\" :\"-\",",
	"		stopstate[n][j]?\"e\" : \"-\",",
	"		progstate[n][j]?\"p\" : \"-\",",
	"		z->atom & 8 ?\"L\":\"G\",",
	"		srcln[j]);",
	"	for (i = 0; z->tp[i]; i++)",
	"		if (z->tp[i] == \'\\n\')",
	"			printf(\"\\\\n\");",
	"		else",
	"			putchar(z->tp[i]);",
	"#if 0",
	"	printf(\"\\n\");",
	"#else",
	"	if (z->qu[0])",
	"	{	printf(\"\\t[\");",
	"		for (i = 0; i < 6; i++)",
	"			if (z->qu[i])",
	"				printf(\"(%%d,%%d)\",",
	"				z->qu[i], z->ty[i]);",
	"		printf(\"]\");",
	"	}",
	"	printf(\"\\n\");",
	"#endif",
	"	fflush(stdout);",
	"}",
	"",
	"#ifdef VAR_RANGES",
	"#define BYTESIZE	32	/* 2^8 : 2^3 = 256:8 = 32 */",
	"",
	"typedef struct Vr_Ptr {",
	"	char	*nm;",
	"	unsigned char vals[BYTESIZE];",
	"	struct Vr_Ptr *nxt;",
	"} Vr_Ptr;",
	"Vr_Ptr *ranges = (Vr_Ptr *) 0;",
	"",
	"void",
	"logval(char *s, int v)",
	"{	Vr_Ptr *tmp;",
	"",
	"	if (v < 0 || v > 255) return;",
	"	for (tmp = ranges; tmp; tmp = tmp->nxt)",
	"		if (!strcmp(tmp->nm, s))",
	"			goto found;",
	"	tmp = (Vr_Ptr *) emalloc(sizeof(Vr_Ptr));",
	"	tmp->nxt = ranges;",
	"	ranges = tmp;",
	"	tmp->nm = s;",
	"found:",
	"	tmp->vals[(v)/8] |= 1<<((v)%%8);",
	"}",
	"",
	"void",
	"dumpval(unsigned char X[], int range)",
	"{	int w, x, i, j = -1;",
	"",
	"	for (w = i = 0; w < range; w++)",
	"	for (x = 0; x < 8; x++, i++)",
	"	{",
	"from:		if ((X[w] & (1<<x)))",
	"		{	printf(\"%%d\", i);",
	"			j = i;",
	"			goto upto;",
	"	}	}",
	"	return;",
	"	for (w = 0; w < range; w++)",
	"	for (x = 0; x < 8; x++, i++)",
	"	{",
	"upto:		if (!(X[w] & (1<<x)))",
	"		{	if (i-1 == j)",
	"				printf(\", \");",
	"			else",
	"				printf(\"-%%d, \", i-1);",
	"			goto from;",
	"	}	}",
	"	if (j >= 0 && j != 255)",
	"		printf(\"-255\");",
	"}",
	"",
	"void",
	"dumpranges(void)",
	"{	Vr_Ptr *tmp;",
	"	printf(\"\\nValues assigned within \");",
	"	printf(\"interval [0..255]:\\n\");",
	"	for (tmp = ranges; tmp; tmp = tmp->nxt)",
	"	{	printf(\"\\t%%s\\t: \", tmp->nm);",
	"		dumpval(tmp->vals, BYTESIZE);",
	"		printf(\"\\n\");",
	"	}",
	"}",
	"#endif",
	0,
};
